package com.rushi.android.vrdemo;


import android.app.Dialog;
import android.content.Context;
import android.view.WindowManager;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;

public class CustomDiaLog extends AlertDialog {

    private boolean noFullScreen = false;

    public CustomDiaLog(@NonNull Context context) {
        super(context);
    }

    public CustomDiaLog(@NonNull Context context, int themeResId) {
        super(context, themeResId);
    }

    protected CustomDiaLog(@NonNull Context context, boolean cancelable, @Nullable OnCancelListener cancelListener) {
        super(context, cancelable, cancelListener);
    }

    @Override
    public void show() {
        super.show();
        try {
            if (getWindow() != null) {
                WindowManager.LayoutParams lp = getWindow().getAttributes();
                //设置宽度
                lp.width = WindowManager.LayoutParams.MATCH_PARENT;
                lp.height = WindowManager.LayoutParams.MATCH_PARENT;
                if (!noFullScreen) {
                    lp.flags = WindowManager.LayoutParams.FLAG_FULLSCREEN;
                }
                getWindow().setAttributes(lp);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void setNoFullScreen(boolean noFullScreen) {
        this.noFullScreen = noFullScreen;
    }
}
