package com.rushi.android.vrdemo;

import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;

import java.util.HashMap;
import java.util.Map;

import static android.content.Context.MODE_PRIVATE;

class Utils {

  public static final String DEFAULT_ANCHOR_URL = "https://realsee.js.org/live-demo/index.html?userRole=anchor";
  public static final String DEFAULT_AUDIENCE_URL = "https://realsee.js.org/live-demo/index.html?userRole=audience";
//  public static final String DEFAULT_URL = "http://10.33.196.251:8080/index_new.html?t="+System.currentTimeMillis();
  public static final String DEFAULT_URL = "https://mvr.realsee.cn/vr/80LvK29zRoV7W9Jowd/Lmrw92zraLFlOpWi5x/9aqB4Zv3GNKe7FdL/2e2b?product=realsee_vr_app&third_params=8888800000";
  //public static final String DEFAULT_URL = "http://10.33.192.172:8080/index_new.html?t="+System.currentTimeMillis();
  //public static final String DEFAULT_URL = "http://docs-realsee.ke.com/live-demo/?userRole=audience&loadingType=0";
  //public static final String DEFAULT_URL = "http://10.33.193.22:8080/index_new.html";
  //public static final String DEFAULT_URL = "http://10.33.192.117:3000?userRole=anchor";

  private static final String DEFAULT_USER_ID = "";
  private static final String DEFAULT_USER_TOKEN = "";
  // 测试用appId， 实际接入使用需要申请正式appId
  private static final String DEFAULT_APP_ID_TEST = "1016";
  // 测试用appSecret， 实际接入使用需要申请正式appId
  private static final String DEFAULT_APP_SECRET_TEST = "123123";


  private static SharedPreferences mSharedPreferences;

  public static void initSp(Context context){
    mSharedPreferences = context.getSharedPreferences("vr-test",MODE_PRIVATE);
  }

  public static String getUrl() {
    return mSharedPreferences.getString("url",DEFAULT_URL);
  }

  public static void saveUrl(String url){
    mSharedPreferences.edit().putString("url",url).apply();
  }

  public static String getUserId() {
    return mSharedPreferences.getString("userId",DEFAULT_USER_ID);
  }

  public static String getAccessToken() {
    return mSharedPreferences.getString("accessToken",DEFAULT_USER_TOKEN);
  }

  public static void saveUserId(String userId){
    mSharedPreferences.edit().putString("userId",userId).apply();
  }

  public static void saveUserName(String userName){
    mSharedPreferences.edit().putString("userName",userName).apply();
  }

  public static void saveAccessToken(String accessToken){
    mSharedPreferences.edit().putString("accessToken",accessToken).apply();
  }

  public static String getAppId() {
    return mSharedPreferences.getString("appId",DEFAULT_APP_ID_TEST);
  }

  public static void saveAppId(String appId){
    mSharedPreferences.edit().putString("appId",appId).apply();
  }

  public static void saveAppSecret(String appId){
    mSharedPreferences.edit().putString("appSecret",appId).apply();
  }

  public static String getAppSecret() {
    return mSharedPreferences.getString("appSecret",DEFAULT_APP_SECRET_TEST);
  }

  public static String getUserName() {
    return mSharedPreferences.getString("userName","");
  }


  public static boolean isTest() {
    return mSharedPreferences.getBoolean("env",true);
  }

  public static Bitmap contentsToBitMap(String qrCode,int width,int height){
    try {
      return bitMatrixToBitmap(encode(qrCode,width,height));
    } catch (WriterException e) {
      e.printStackTrace();
    }
    return null;
  }

  private static BitMatrix encode(String contents,int width,int height) throws WriterException {
    final Map<EncodeHintType, Object> hints = new HashMap<>();
    hints.put(EncodeHintType.ERROR_CORRECTION, ErrorCorrectionLevel.H);
    hints.put(EncodeHintType.CHARACTER_SET, "utf-8");
    return new QRCodeWriter().encode(contents, BarcodeFormat.QR_CODE, width, height, hints);
  }

  private static Bitmap bitMatrixToBitmap(BitMatrix bitMatrix) {
    final int width = bitMatrix.getWidth();
    final int height = bitMatrix.getHeight();
    final int[] pixels = new int[width * height];
    for (int y = 0; y < height; y++) {
      for (int x = 0; x < width; x++) {
        pixels[y * width + x] = bitMatrix.get(x, y) ? 0xFF000000 : 0xFFFFFFFF;
      }
    }
    Bitmap bitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
    bitmap.setPixels(pixels, 0, width, 0, 0, width, height);

    return bitmap;
  }

  public static void checkTest(boolean isChecked){
    mSharedPreferences.edit().putBoolean("env",isChecked).apply();
  }
}
